<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--用户数据-->
      <el-col :span="24" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="用户昵称" prop="memberNickName">
            <el-input
              v-model="queryParams.memberNickName"
              placeholder="请输入用户昵称"
              clearable
              style="width: 240px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="类型" prop="type">
            <el-select v-model="queryParams.type" clearable placeholder="请选择状态">
              <el-option
                v-for="dict in dict.type.tourism_suggestions_type"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <el-row :gutter="10" class="mb8">
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
        </el-row>
        <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
          <el-table-column type="index" label="编号" align="center"  />
          <el-table-column label="用户昵称" align="center" key="memberNickName" prop="memberNickName" v-if="columns[0].visible" />
          <el-table-column label="类型" align="center" key="type" prop="type" v-if="columns[1].visible" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              <dict-tag :options="dict.type.tourism_suggestions_type" :value="scope.row.type"/>
            </template>
          </el-table-column>
          <el-table-column label="留言内容" align="center" key="content" v-if="columns[2].visible" :show-overflow-tooltip="true">
            <template slot-scope="scope">
              <el-tooltip class="item" effect="dark" :content="scope.row.content" placement="top">
                <div style="width: 100%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">
                  <span style="width: 100%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">{{ scope.row.content }}</span>
                </div>
              </el-tooltip>
            </template>
          </el-table-column>
          <el-table-column label="留言时间" align="center" key="createTime" prop="createTime" v-if="columns[3].visible" />
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </el-col>
    </el-row>
  </div>
</template>

<script>
import { 
  listTableApi, 
  delTableParamsApi, 
  } from "@/api/CURD";
export default {
  name: "User",
  dicts: ['tourism_suggestions_type'],
  components: {},
  data() {
    return {
      title: "投诉建议",// 通用标题
      configPermi: {
        add: ['system:user:edit'], // 新增权限
        details: ['system:user:details'], // 详情权限
        delect: ['system:user:remove'], // 删除权限
        edit: ['system:user:edit'], // 编辑权限
        upload: ['system:user:upload'],// 导入权限
        export: ['system:user:export'],// 导出权限
      },
      configUrl: {
        list: '/merchant/memberSuggestion/pageList', // 列表地址
        delect: '', // 删除地址
        upload: '',// 导入地址
        download:'', // 下载模板地址
        export: '',// 导出地址
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      tableList: null,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
      dateRange: [],
      // 控制列表是否显示
      columns: [
        { key: 0, label: `用户昵称`, visible: true },
        { key: 2, label: `类型`, visible: true },
        { key: 3, label: `留言内容`, visible: true },
        { key: 4, label: `留言时间`, visible: true },
      ],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询用户列表 */
    getList() {
      this.loading = true;
      listTableApi(
        this.configUrl.list,
        this.addDateRange(
          this.queryParams, 
          this.dateRange)).then(response => {
            this.tableList = response.data.rows;
            this.total = response.data.total;
            this.loading = false;
        }
      ).catch (error=>{
        console.error('获取列表失败!!!!',error)
        this.tableList = [];
        this.total = 0;
        this.loading = false
      }) 
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
      }
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      if(this.$refs.addAndEdit) {
        this.$refs.addAndEdit.initData(this.title + '新增', "ADD",{})
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      if(this.$refs.addAndEdit) {
        this.$refs.addAndEdit.initData(this.title + '编辑', "EDITInit",{...row})
      }
    },
    handleDetails(row){
      if(this.$refs.detailsBox) {
        this.$refs.detailsBox.initData(this.title + '详情',"DEATILSInit", row)
      }
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除用户编号为"' + ids + '"的数据项？').then( () => {
        return delTableParamsApi(this.configUrl.delect,{
          id: ids
        });
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch((e) => {
        console.error("删除失败====",e)
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(this.configUrl.export, {
        ...this.queryParams
      }, `${this.title }_${new Date().getTime()}.xlsx`)
    },
    /** 导入按钮操作 */
    handleImport() {
      if(this.$refs.upload) {
        this.$refs.upload.initData({
          width: '400px',
          // 弹出层标题（用户导入）
          title: this.title + "导入",
          // 下载模板地址
          importTemplate: this.configUrl.download,
          // 上传的地址
          url: this.configUrl.upload
        })
      }
    },
  }
};
</script>
